/* BlurEffect.c generated by valac 0.56.18, the Vala compiler
 * generated from BlurEffect.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cogl/cogl.h>
#include <graphene-gobject.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>

#define GREETER_COMPOSITOR_BLUR_EFFECT_MIN_DOWNSCALE_SIZE 256.0f
#define GREETER_COMPOSITOR_BLUR_EFFECT_MAX_RADIUS 12.0f
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_COMPOSITOR_TYPE_BLUR_EFFECT (greeter_compositor_blur_effect_get_type ())
#define GREETER_COMPOSITOR_BLUR_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffect))
#define GREETER_COMPOSITOR_BLUR_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffectClass))
#define GREETER_COMPOSITOR_IS_BLUR_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_BLUR_EFFECT))
#define GREETER_COMPOSITOR_IS_BLUR_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_BLUR_EFFECT))
#define GREETER_COMPOSITOR_BLUR_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffectClass))

typedef struct _GreeterCompositorBlurEffect GreeterCompositorBlurEffect;
typedef struct _GreeterCompositorBlurEffectClass GreeterCompositorBlurEffectClass;
typedef struct _GreeterCompositorBlurEffectPrivate GreeterCompositorBlurEffectPrivate;
enum  {
	GREETER_COMPOSITOR_BLUR_EFFECT_0_PROPERTY,
	GREETER_COMPOSITOR_BLUR_EFFECT_ACTOR_PROPERTY,
	GREETER_COMPOSITOR_BLUR_EFFECT_RADIUS_PROPERTY,
	GREETER_COMPOSITOR_BLUR_EFFECT_NUM_PROPERTIES
};
static GParamSpec* greeter_compositor_blur_effect_properties[GREETER_COMPOSITOR_BLUR_EFFECT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _clutter_paint_node_unref0(var) ((var == NULL) ? NULL : (var = (clutter_paint_node_unref (var), NULL)))

struct _GreeterCompositorBlurEffect {
	ClutterEffect parent_instance;
	GreeterCompositorBlurEffectPrivate * priv;
};

struct _GreeterCompositorBlurEffectClass {
	ClutterEffectClass parent_class;
};

struct _GreeterCompositorBlurEffectPrivate {
	ClutterActor* _actor;
	gfloat _radius;
	gboolean actor_painted;
	gboolean blur_applied;
	gint texture_width;
	gint texture_height;
	gfloat downscale_factor;
	CoglFramebuffer* actor_framebuffer;
	CoglPipeline* actor_pipeline;
	CoglTexture* actor_texture;
	CoglFramebuffer* framebuffer;
	CoglPipeline* pipeline;
	CoglTexture* texture;
};

static gint GreeterCompositorBlurEffect_private_offset;
static gpointer greeter_compositor_blur_effect_parent_class = NULL;

VALA_EXTERN GType greeter_compositor_blur_effect_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorBlurEffect, g_object_unref)
VALA_EXTERN GreeterCompositorBlurEffect* greeter_compositor_blur_effect_new (ClutterActor* actor,
                                                                 gfloat radius);
VALA_EXTERN GreeterCompositorBlurEffect* greeter_compositor_blur_effect_construct (GType object_type,
                                                                       ClutterActor* actor,
                                                                       gfloat radius);
static gboolean greeter_compositor_blur_effect_needs_repaint (GreeterCompositorBlurEffect* self,
                                                       ClutterEffectPaintFlags flags);
static void greeter_compositor_blur_effect_update_actor_box (GreeterCompositorBlurEffect* self,
                                                      ClutterPaintContext* paint_context,
                                                      ClutterActorBox* result);
VALA_EXTERN ClutterActor* greeter_compositor_blur_effect_get_actor (GreeterCompositorBlurEffect* self);
static gfloat greeter_compositor_blur_effect_calculate_downscale_factor (GreeterCompositorBlurEffect* self,
                                                                  gfloat width,
                                                                  gfloat height,
                                                                  gfloat radius);
static void greeter_compositor_blur_effect_setup_projection_matrix (GreeterCompositorBlurEffect* self,
                                                             CoglFramebuffer* framebuffer,
                                                             gfloat width,
                                                             gfloat height);
static gboolean greeter_compositor_blur_effect_update_general_fbo (GreeterCompositorBlurEffect* self,
                                                            gint width,
                                                            gint height,
                                                            gfloat downscale_factor);
static gboolean greeter_compositor_blur_effect_update_actor_fbo (GreeterCompositorBlurEffect* self,
                                                          gint width,
                                                          gint height,
                                                          gfloat downscale_factor);
static gboolean greeter_compositor_blur_effect_update_framebuffers (GreeterCompositorBlurEffect* self,
                                                             ClutterPaintContext* paint_context,
                                                             ClutterActorBox* actor_box);
VALA_EXTERN gfloat greeter_compositor_blur_effect_get_radius (GreeterCompositorBlurEffect* self);
static ClutterPaintNode* greeter_compositor_blur_effect_create_blur_nodes (GreeterCompositorBlurEffect* self,
                                                                    ClutterPaintNode* node);
static void greeter_compositor_blur_effect_paint_actor_offscreen (GreeterCompositorBlurEffect* self,
                                                           ClutterPaintNode* node,
                                                           ClutterEffectPaintFlags flags);
static void greeter_compositor_blur_effect_add_actor_node (GreeterCompositorBlurEffect* self,
                                                    ClutterPaintNode* node);
static void greeter_compositor_blur_effect_add_blurred_pipeline (GreeterCompositorBlurEffect* self,
                                                          ClutterPaintNode* node);
static void greeter_compositor_blur_effect_real_paint_node (ClutterEffect* base,
                                                     ClutterPaintNode* node,
                                                     ClutterPaintContext* paint_context,
                                                     ClutterEffectPaintFlags flags);
static void greeter_compositor_blur_effect_set_actor (GreeterCompositorBlurEffect* self,
                                               ClutterActor* value);
static void greeter_compositor_blur_effect_set_radius (GreeterCompositorBlurEffect* self,
                                                gfloat value);
static GObject * greeter_compositor_blur_effect_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void greeter_compositor_blur_effect_finalize (GObject * obj);
static GType greeter_compositor_blur_effect_get_type_once (void);
static void _vala_greeter_compositor_blur_effect_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_greeter_compositor_blur_effect_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
greeter_compositor_blur_effect_get_instance_private (GreeterCompositorBlurEffect* self)
{
	return G_STRUCT_MEMBER_P (self, GreeterCompositorBlurEffect_private_offset);
}

GreeterCompositorBlurEffect*
greeter_compositor_blur_effect_construct (GType object_type,
                                          ClutterActor* actor,
                                          gfloat radius)
{
	GreeterCompositorBlurEffect * self = NULL;
#line 27 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 28 "../compositor/Background/BlurEffect.vala"
	self = (GreeterCompositorBlurEffect*) g_object_new (object_type, "actor", actor, "radius", radius, NULL);
#line 27 "../compositor/Background/BlurEffect.vala"
	return self;
#line 173 "BlurEffect.c"
}

GreeterCompositorBlurEffect*
greeter_compositor_blur_effect_new (ClutterActor* actor,
                                    gfloat radius)
{
#line 27 "../compositor/Background/BlurEffect.vala"
	return greeter_compositor_blur_effect_construct (GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, actor, radius);
#line 182 "BlurEffect.c"
}

static gboolean
greeter_compositor_blur_effect_needs_repaint (GreeterCompositorBlurEffect* self,
                                              ClutterEffectPaintFlags flags)
{
	gboolean actor_dirty = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 45 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../compositor/Background/BlurEffect.vala"
	actor_dirty = (flags & CLUTTER_EFFECT_PAINT_ACTOR_DIRTY) != 0;
#line 48 "../compositor/Background/BlurEffect.vala"
	if (actor_dirty) {
#line 48 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = TRUE;
#line 201 "BlurEffect.c"
	} else {
#line 48 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = !self->priv->blur_applied;
#line 205 "BlurEffect.c"
	}
#line 48 "../compositor/Background/BlurEffect.vala"
	if (_tmp1_) {
#line 48 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = TRUE;
#line 211 "BlurEffect.c"
	} else {
#line 48 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = !self->priv->actor_painted;
#line 215 "BlurEffect.c"
	}
#line 48 "../compositor/Background/BlurEffect.vala"
	result = _tmp0_;
#line 48 "../compositor/Background/BlurEffect.vala"
	return result;
#line 221 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_update_actor_box (GreeterCompositorBlurEffect* self,
                                                 ClutterPaintContext* paint_context,
                                                 ClutterActorBox* result)
{
	ClutterActorBox actor_allocation_box = {0};
	ClutterActor* _tmp0_;
	ClutterActorBox _tmp1_ = {0};
#line 51 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 51 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (paint_context != NULL);
#line 52 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 52 "../compositor/Background/BlurEffect.vala"
	clutter_actor_get_allocation_box (_tmp0_, &_tmp1_);
#line 52 "../compositor/Background/BlurEffect.vala"
	actor_allocation_box = _tmp1_;
#line 53 "../compositor/Background/BlurEffect.vala"
	clutter_actor_box_clamp_to_pixel (&actor_allocation_box);
#line 55 "../compositor/Background/BlurEffect.vala"
	*result = actor_allocation_box;
#line 55 "../compositor/Background/BlurEffect.vala"
	return;
#line 248 "BlurEffect.c"
}

static gfloat
greeter_compositor_blur_effect_calculate_downscale_factor (GreeterCompositorBlurEffect* self,
                                                           gfloat width,
                                                           gfloat height,
                                                           gfloat radius)
{
	gfloat downscale_factor = 0.0F;
	gfloat scaled_width = 0.0F;
	gfloat scaled_height = 0.0F;
	gfloat scaled_radius = 0.0F;
	gfloat result;
#line 58 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 59 "../compositor/Background/BlurEffect.vala"
	downscale_factor = 1.0f;
#line 60 "../compositor/Background/BlurEffect.vala"
	scaled_width = width;
#line 61 "../compositor/Background/BlurEffect.vala"
	scaled_height = height;
#line 62 "../compositor/Background/BlurEffect.vala"
	scaled_radius = radius;
#line 68 "../compositor/Background/BlurEffect.vala"
	while (TRUE) {
#line 274 "BlurEffect.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 69 "../compositor/Background/BlurEffect.vala"
		if (scaled_radius > GREETER_COMPOSITOR_BLUR_EFFECT_MAX_RADIUS) {
#line 70 "../compositor/Background/BlurEffect.vala"
			_tmp1_ = scaled_width > GREETER_COMPOSITOR_BLUR_EFFECT_MIN_DOWNSCALE_SIZE;
#line 281 "BlurEffect.c"
		} else {
#line 69 "../compositor/Background/BlurEffect.vala"
			_tmp1_ = FALSE;
#line 285 "BlurEffect.c"
		}
#line 69 "../compositor/Background/BlurEffect.vala"
		if (_tmp1_) {
#line 71 "../compositor/Background/BlurEffect.vala"
			_tmp0_ = scaled_height > GREETER_COMPOSITOR_BLUR_EFFECT_MIN_DOWNSCALE_SIZE;
#line 291 "BlurEffect.c"
		} else {
#line 69 "../compositor/Background/BlurEffect.vala"
			_tmp0_ = FALSE;
#line 295 "BlurEffect.c"
		}
#line 69 "../compositor/Background/BlurEffect.vala"
		if (!_tmp0_) {
#line 69 "../compositor/Background/BlurEffect.vala"
			break;
#line 301 "BlurEffect.c"
		}
#line 73 "../compositor/Background/BlurEffect.vala"
		downscale_factor *= 2.0f;
#line 75 "../compositor/Background/BlurEffect.vala"
		scaled_width = width / downscale_factor;
#line 76 "../compositor/Background/BlurEffect.vala"
		scaled_height = height / downscale_factor;
#line 77 "../compositor/Background/BlurEffect.vala"
		scaled_radius = radius / downscale_factor;
#line 311 "BlurEffect.c"
	}
#line 80 "../compositor/Background/BlurEffect.vala"
	result = downscale_factor;
#line 80 "../compositor/Background/BlurEffect.vala"
	return result;
#line 317 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_setup_projection_matrix (GreeterCompositorBlurEffect* self,
                                                        CoglFramebuffer* framebuffer,
                                                        gfloat width,
                                                        gfloat height)
{
	graphene_matrix_t projection = {0};
	graphene_matrix_t _tmp0_ = {0};
	graphene_point3d_t _tmp1_ = {0};
	graphene_matrix_t _tmp2_;
#line 83 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 83 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (framebuffer != NULL);
#line 84 "../compositor/Background/BlurEffect.vala"
	projection = _tmp0_;
#line 85 "../compositor/Background/BlurEffect.vala"
	_tmp1_.x = (-width) / 2.0f;
#line 85 "../compositor/Background/BlurEffect.vala"
	_tmp1_.y = (-height) / 2.0f;
#line 85 "../compositor/Background/BlurEffect.vala"
	_tmp1_.z = 0.0f;
#line 85 "../compositor/Background/BlurEffect.vala"
	graphene_matrix_init_translate (&projection, &_tmp1_);
#line 86 "../compositor/Background/BlurEffect.vala"
	graphene_matrix_scale (&projection, 2.0f / width, (-2.0f) / height, 1.0f);
#line 88 "../compositor/Background/BlurEffect.vala"
	_tmp2_ = projection;
#line 88 "../compositor/Background/BlurEffect.vala"
	cogl_framebuffer_set_projection_matrix (framebuffer, &_tmp2_);
#line 350 "BlurEffect.c"
}

static gboolean
greeter_compositor_blur_effect_update_general_fbo (GreeterCompositorBlurEffect* self,
                                                   gint width,
                                                   gint height,
                                                   gfloat downscale_factor)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	CoglContext* ctx = NULL;
	ClutterBackend* _tmp4_;
	CoglContext* _tmp5_;
	gint new_width = 0;
	gint new_height = 0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp6_;
	CoglPipeline* _tmp17_;
	CoglTexture* _tmp18_;
	CoglTexture* _tmp19_;
	CoglOffscreen* _tmp20_;
	CoglFramebuffer* _tmp21_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 91 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../compositor/Background/BlurEffect.vala"
	if (self->priv->texture_width == width) {
#line 94 "../compositor/Background/BlurEffect.vala"
		_tmp2_ = self->priv->texture_height == height;
#line 382 "BlurEffect.c"
	} else {
#line 93 "../compositor/Background/BlurEffect.vala"
		_tmp2_ = FALSE;
#line 386 "BlurEffect.c"
	}
#line 93 "../compositor/Background/BlurEffect.vala"
	if (_tmp2_) {
#line 95 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = self->priv->downscale_factor == downscale_factor;
#line 392 "BlurEffect.c"
	} else {
#line 93 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = FALSE;
#line 396 "BlurEffect.c"
	}
#line 93 "../compositor/Background/BlurEffect.vala"
	if (_tmp1_) {
#line 400 "BlurEffect.c"
		CoglFramebuffer* _tmp3_;
#line 96 "../compositor/Background/BlurEffect.vala"
		_tmp3_ = self->priv->framebuffer;
#line 96 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 406 "BlurEffect.c"
	} else {
#line 93 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = FALSE;
#line 410 "BlurEffect.c"
	}
#line 92 "../compositor/Background/BlurEffect.vala"
	if (_tmp0_) {
#line 98 "../compositor/Background/BlurEffect.vala"
		result = TRUE;
#line 98 "../compositor/Background/BlurEffect.vala"
		return result;
#line 418 "BlurEffect.c"
	}
#line 101 "../compositor/Background/BlurEffect.vala"
	_tmp4_ = clutter_get_default_backend ();
#line 101 "../compositor/Background/BlurEffect.vala"
	_tmp5_ = clutter_backend_get_cogl_context (_tmp4_);
#line 101 "../compositor/Background/BlurEffect.vala"
	ctx = _tmp5_;
#line 103 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->framebuffer);
#line 103 "../compositor/Background/BlurEffect.vala"
	self->priv->framebuffer = NULL;
#line 104 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->texture);
#line 104 "../compositor/Background/BlurEffect.vala"
	self->priv->texture = NULL;
#line 106 "../compositor/Background/BlurEffect.vala"
	new_width = (gint) floorf (width / downscale_factor);
#line 107 "../compositor/Background/BlurEffect.vala"
	new_height = (gint) floorf (height / downscale_factor);
#line 109 "../compositor/Background/BlurEffect.vala"
	_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, new_width, new_height);
#line 109 "../compositor/Background/BlurEffect.vala"
	surface = _tmp6_;
#line 442 "BlurEffect.c"
	{
		CoglTexture2D* _tmp7_ = NULL;
		CoglContext* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		guchar* _tmp11_;
		CoglTexture2D* _tmp12_;
		CoglTexture2D* _tmp13_;
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp8_ = ctx;
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp9_ = surface;
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp10_ = surface;
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp11_ = cairo_image_surface_get_data (_tmp10_);
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp12_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (_tmp8_, new_width, new_height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp9_), _tmp11_, &_inner_error0_);
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp7_ = _tmp12_;
#line 112 "../compositor/Background/BlurEffect.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 465 "BlurEffect.c"
			goto __catch0_g_error;
		}
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp13_ = _tmp7_;
#line 112 "../compositor/Background/BlurEffect.vala"
		_tmp7_ = NULL;
#line 112 "../compositor/Background/BlurEffect.vala"
		_g_object_unref0 (self->priv->texture);
#line 112 "../compositor/Background/BlurEffect.vala"
		self->priv->texture = (CoglTexture*) _tmp13_;
#line 111 "../compositor/Background/BlurEffect.vala"
		_g_object_unref0 (_tmp7_);
#line 478 "BlurEffect.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 111 "../compositor/Background/BlurEffect.vala"
		e = _inner_error0_;
#line 111 "../compositor/Background/BlurEffect.vala"
		_inner_error0_ = NULL;
#line 114 "../compositor/Background/BlurEffect.vala"
		_tmp14_ = e;
#line 114 "../compositor/Background/BlurEffect.vala"
		_tmp15_ = _tmp14_->message;
#line 114 "../compositor/Background/BlurEffect.vala"
		g_warning ("BlurEffect.vala:114: %s", _tmp15_);
#line 115 "../compositor/Background/BlurEffect.vala"
		result = FALSE;
#line 115 "../compositor/Background/BlurEffect.vala"
		_g_error_free0 (e);
#line 115 "../compositor/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 115 "../compositor/Background/BlurEffect.vala"
		return result;
#line 504 "BlurEffect.c"
	}
	__finally0:
#line 111 "../compositor/Background/BlurEffect.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 509 "BlurEffect.c"
		gboolean _tmp16_ = FALSE;
#line 111 "../compositor/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 111 "../compositor/Background/BlurEffect.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../compositor/Background/BlurEffect.vala"
		g_clear_error (&_inner_error0_);
#line 111 "../compositor/Background/BlurEffect.vala"
		return _tmp16_;
#line 519 "BlurEffect.c"
	}
#line 118 "../compositor/Background/BlurEffect.vala"
	_tmp17_ = self->priv->pipeline;
#line 118 "../compositor/Background/BlurEffect.vala"
	_tmp18_ = self->priv->texture;
#line 118 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_texture (_tmp17_, 0, _tmp18_);
#line 120 "../compositor/Background/BlurEffect.vala"
	_tmp19_ = self->priv->texture;
#line 120 "../compositor/Background/BlurEffect.vala"
	_tmp20_ = cogl_offscreen_new_with_texture (_tmp19_);
#line 120 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->framebuffer);
#line 120 "../compositor/Background/BlurEffect.vala"
	self->priv->framebuffer = (CoglFramebuffer*) _tmp20_;
#line 122 "../compositor/Background/BlurEffect.vala"
	_tmp21_ = self->priv->framebuffer;
#line 122 "../compositor/Background/BlurEffect.vala"
	greeter_compositor_blur_effect_setup_projection_matrix (self, _tmp21_, (gfloat) new_width, (gfloat) new_height);
#line 124 "../compositor/Background/BlurEffect.vala"
	result = TRUE;
#line 124 "../compositor/Background/BlurEffect.vala"
	_cairo_surface_destroy0 (surface);
#line 124 "../compositor/Background/BlurEffect.vala"
	return result;
#line 545 "BlurEffect.c"
}

static gboolean
greeter_compositor_blur_effect_update_actor_fbo (GreeterCompositorBlurEffect* self,
                                                 gint width,
                                                 gint height,
                                                 gfloat downscale_factor)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	CoglContext* ctx = NULL;
	ClutterBackend* _tmp4_;
	CoglContext* _tmp5_;
	gint new_width = 0;
	gint new_height = 0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp6_;
	CoglPipeline* _tmp17_;
	CoglTexture* _tmp18_;
	CoglTexture* _tmp19_;
	CoglOffscreen* _tmp20_;
	CoglFramebuffer* _tmp21_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 127 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../compositor/Background/BlurEffect.vala"
	if (self->priv->texture_width == width) {
#line 130 "../compositor/Background/BlurEffect.vala"
		_tmp2_ = self->priv->texture_height == height;
#line 577 "BlurEffect.c"
	} else {
#line 129 "../compositor/Background/BlurEffect.vala"
		_tmp2_ = FALSE;
#line 581 "BlurEffect.c"
	}
#line 129 "../compositor/Background/BlurEffect.vala"
	if (_tmp2_) {
#line 131 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = self->priv->downscale_factor == downscale_factor;
#line 587 "BlurEffect.c"
	} else {
#line 129 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = FALSE;
#line 591 "BlurEffect.c"
	}
#line 129 "../compositor/Background/BlurEffect.vala"
	if (_tmp1_) {
#line 595 "BlurEffect.c"
		CoglFramebuffer* _tmp3_;
#line 132 "../compositor/Background/BlurEffect.vala"
		_tmp3_ = self->priv->actor_framebuffer;
#line 132 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 601 "BlurEffect.c"
	} else {
#line 129 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = FALSE;
#line 605 "BlurEffect.c"
	}
#line 128 "../compositor/Background/BlurEffect.vala"
	if (_tmp0_) {
#line 134 "../compositor/Background/BlurEffect.vala"
		result = TRUE;
#line 134 "../compositor/Background/BlurEffect.vala"
		return result;
#line 613 "BlurEffect.c"
	}
#line 137 "../compositor/Background/BlurEffect.vala"
	self->priv->actor_painted = FALSE;
#line 139 "../compositor/Background/BlurEffect.vala"
	_tmp4_ = clutter_get_default_backend ();
#line 139 "../compositor/Background/BlurEffect.vala"
	_tmp5_ = clutter_backend_get_cogl_context (_tmp4_);
#line 139 "../compositor/Background/BlurEffect.vala"
	ctx = _tmp5_;
#line 141 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_framebuffer);
#line 141 "../compositor/Background/BlurEffect.vala"
	self->priv->actor_framebuffer = NULL;
#line 142 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_texture);
#line 142 "../compositor/Background/BlurEffect.vala"
	self->priv->actor_texture = NULL;
#line 144 "../compositor/Background/BlurEffect.vala"
	new_width = (gint) floorf (width / downscale_factor);
#line 145 "../compositor/Background/BlurEffect.vala"
	new_height = (gint) floorf (height / downscale_factor);
#line 147 "../compositor/Background/BlurEffect.vala"
	_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, new_width, new_height);
#line 147 "../compositor/Background/BlurEffect.vala"
	surface = _tmp6_;
#line 639 "BlurEffect.c"
	{
		CoglTexture2D* _tmp7_ = NULL;
		CoglContext* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		guchar* _tmp11_;
		CoglTexture2D* _tmp12_;
		CoglTexture2D* _tmp13_;
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp8_ = ctx;
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp9_ = surface;
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp10_ = surface;
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp11_ = cairo_image_surface_get_data (_tmp10_);
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp12_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (_tmp8_, new_width, new_height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp9_), _tmp11_, &_inner_error0_);
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp7_ = _tmp12_;
#line 150 "../compositor/Background/BlurEffect.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "BlurEffect.c"
			goto __catch0_g_error;
		}
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp13_ = _tmp7_;
#line 150 "../compositor/Background/BlurEffect.vala"
		_tmp7_ = NULL;
#line 150 "../compositor/Background/BlurEffect.vala"
		_g_object_unref0 (self->priv->actor_texture);
#line 150 "../compositor/Background/BlurEffect.vala"
		self->priv->actor_texture = (CoglTexture*) _tmp13_;
#line 149 "../compositor/Background/BlurEffect.vala"
		_g_object_unref0 (_tmp7_);
#line 675 "BlurEffect.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 149 "../compositor/Background/BlurEffect.vala"
		e = _inner_error0_;
#line 149 "../compositor/Background/BlurEffect.vala"
		_inner_error0_ = NULL;
#line 152 "../compositor/Background/BlurEffect.vala"
		_tmp14_ = e;
#line 152 "../compositor/Background/BlurEffect.vala"
		_tmp15_ = _tmp14_->message;
#line 152 "../compositor/Background/BlurEffect.vala"
		g_warning ("BlurEffect.vala:152: %s", _tmp15_);
#line 153 "../compositor/Background/BlurEffect.vala"
		result = FALSE;
#line 153 "../compositor/Background/BlurEffect.vala"
		_g_error_free0 (e);
#line 153 "../compositor/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 153 "../compositor/Background/BlurEffect.vala"
		return result;
#line 701 "BlurEffect.c"
	}
	__finally0:
#line 149 "../compositor/Background/BlurEffect.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 706 "BlurEffect.c"
		gboolean _tmp16_ = FALSE;
#line 149 "../compositor/Background/BlurEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 149 "../compositor/Background/BlurEffect.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../compositor/Background/BlurEffect.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../compositor/Background/BlurEffect.vala"
		return _tmp16_;
#line 716 "BlurEffect.c"
	}
#line 156 "../compositor/Background/BlurEffect.vala"
	_tmp17_ = self->priv->actor_pipeline;
#line 156 "../compositor/Background/BlurEffect.vala"
	_tmp18_ = self->priv->actor_texture;
#line 156 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_texture (_tmp17_, 0, _tmp18_);
#line 158 "../compositor/Background/BlurEffect.vala"
	_tmp19_ = self->priv->actor_texture;
#line 158 "../compositor/Background/BlurEffect.vala"
	_tmp20_ = cogl_offscreen_new_with_texture (_tmp19_);
#line 158 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_framebuffer);
#line 158 "../compositor/Background/BlurEffect.vala"
	self->priv->actor_framebuffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, cogl_framebuffer_get_type (), CoglFramebuffer);
#line 160 "../compositor/Background/BlurEffect.vala"
	_tmp21_ = self->priv->actor_framebuffer;
#line 160 "../compositor/Background/BlurEffect.vala"
	greeter_compositor_blur_effect_setup_projection_matrix (self, _tmp21_, (gfloat) new_width, (gfloat) new_height);
#line 162 "../compositor/Background/BlurEffect.vala"
	result = TRUE;
#line 162 "../compositor/Background/BlurEffect.vala"
	_cairo_surface_destroy0 (surface);
#line 162 "../compositor/Background/BlurEffect.vala"
	return result;
#line 742 "BlurEffect.c"
}

static gboolean
greeter_compositor_blur_effect_update_framebuffers (GreeterCompositorBlurEffect* self,
                                                    ClutterPaintContext* paint_context,
                                                    ClutterActorBox* actor_box)
{
	gint width = 0;
	gint height = 0;
	gfloat downscale_factor = 0.0F;
	gfloat _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean updated = FALSE;
	gboolean result;
#line 165 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (paint_context != NULL, FALSE);
#line 165 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (actor_box != NULL, FALSE);
#line 166 "../compositor/Background/BlurEffect.vala"
	width = (gint) clutter_actor_box_get_width (actor_box);
#line 167 "../compositor/Background/BlurEffect.vala"
	height = (gint) clutter_actor_box_get_height (actor_box);
#line 169 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_radius;
#line 169 "../compositor/Background/BlurEffect.vala"
	downscale_factor = greeter_compositor_blur_effect_calculate_downscale_factor (self, (gfloat) width, (gfloat) height, _tmp0_);
#line 171 "../compositor/Background/BlurEffect.vala"
	if (greeter_compositor_blur_effect_update_actor_fbo (self, width, height, downscale_factor)) {
#line 171 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = greeter_compositor_blur_effect_update_general_fbo (self, width, height, downscale_factor);
#line 775 "BlurEffect.c"
	} else {
#line 171 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = FALSE;
#line 779 "BlurEffect.c"
	}
#line 171 "../compositor/Background/BlurEffect.vala"
	updated = _tmp1_;
#line 173 "../compositor/Background/BlurEffect.vala"
	self->priv->texture_width = width;
#line 174 "../compositor/Background/BlurEffect.vala"
	self->priv->texture_height = height;
#line 175 "../compositor/Background/BlurEffect.vala"
	self->priv->downscale_factor = downscale_factor;
#line 177 "../compositor/Background/BlurEffect.vala"
	result = updated;
#line 177 "../compositor/Background/BlurEffect.vala"
	return result;
#line 793 "BlurEffect.c"
}

static ClutterPaintNode*
greeter_compositor_blur_effect_create_blur_nodes (GreeterCompositorBlurEffect* self,
                                                  ClutterPaintNode* node)
{
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	ClutterActor* _tmp0_;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	ClutterLayerNode* general_node = NULL;
	CoglFramebuffer* _tmp3_;
	CoglPipeline* _tmp4_;
	ClutterLayerNode* _tmp5_;
	ClutterActorBox _tmp6_ = {0};
	ClutterBlurNode* blur_node = NULL;
	gfloat _tmp7_;
	ClutterBlurNode* _tmp8_;
	CoglTexture* _tmp9_;
	CoglTexture* _tmp10_;
	ClutterActorBox _tmp11_ = {0};
	ClutterPaintNode* result;
#line 180 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 182 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 182 "../compositor/Background/BlurEffect.vala"
	clutter_actor_get_size (_tmp0_, &_tmp1_, &_tmp2_);
#line 182 "../compositor/Background/BlurEffect.vala"
	width = _tmp1_;
#line 182 "../compositor/Background/BlurEffect.vala"
	height = _tmp2_;
#line 184 "../compositor/Background/BlurEffect.vala"
	_tmp3_ = self->priv->framebuffer;
#line 184 "../compositor/Background/BlurEffect.vala"
	_tmp4_ = self->priv->pipeline;
#line 184 "../compositor/Background/BlurEffect.vala"
	_tmp5_ = (ClutterLayerNode*) clutter_layer_node_new_to_framebuffer (_tmp3_, _tmp4_);
#line 184 "../compositor/Background/BlurEffect.vala"
	general_node = _tmp5_;
#line 185 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_child (node, (ClutterPaintNode*) general_node);
#line 186 "../compositor/Background/BlurEffect.vala"
	_tmp6_.x1 = 0.0f;
#line 186 "../compositor/Background/BlurEffect.vala"
	_tmp6_.y1 = 0.0f;
#line 186 "../compositor/Background/BlurEffect.vala"
	_tmp6_.x2 = width;
#line 186 "../compositor/Background/BlurEffect.vala"
	_tmp6_.y2 = height;
#line 186 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_rectangle ((ClutterPaintNode*) general_node, &_tmp6_);
#line 188 "../compositor/Background/BlurEffect.vala"
	_tmp7_ = self->priv->_radius;
#line 188 "../compositor/Background/BlurEffect.vala"
	_tmp8_ = (ClutterBlurNode*) clutter_blur_node_new ((guint) (self->priv->texture_width / self->priv->downscale_factor), (guint) (self->priv->texture_height / self->priv->downscale_factor), _tmp7_ / self->priv->downscale_factor);
#line 188 "../compositor/Background/BlurEffect.vala"
	blur_node = _tmp8_;
#line 193 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_child ((ClutterPaintNode*) general_node, (ClutterPaintNode*) blur_node);
#line 194 "../compositor/Background/BlurEffect.vala"
	_tmp9_ = self->priv->texture;
#line 194 "../compositor/Background/BlurEffect.vala"
	_tmp10_ = self->priv->texture;
#line 194 "../compositor/Background/BlurEffect.vala"
	_tmp11_.x1 = 0.0f;
#line 194 "../compositor/Background/BlurEffect.vala"
	_tmp11_.y1 = 0.0f;
#line 194 "../compositor/Background/BlurEffect.vala"
	_tmp11_.x2 = (gfloat) cogl_texture_get_width (_tmp9_);
#line 194 "../compositor/Background/BlurEffect.vala"
	_tmp11_.y2 = (gfloat) cogl_texture_get_height (_tmp10_);
#line 194 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_rectangle ((ClutterPaintNode*) blur_node, &_tmp11_);
#line 201 "../compositor/Background/BlurEffect.vala"
	self->priv->blur_applied = TRUE;
#line 203 "../compositor/Background/BlurEffect.vala"
	result = (ClutterPaintNode*) blur_node;
#line 203 "../compositor/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (general_node);
#line 203 "../compositor/Background/BlurEffect.vala"
	return result;
#line 879 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_paint_actor_offscreen (GreeterCompositorBlurEffect* self,
                                                      ClutterPaintNode* node,
                                                      ClutterEffectPaintFlags flags)
{
	gboolean actor_dirty = FALSE;
	gboolean _tmp0_ = FALSE;
#line 206 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 206 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 207 "../compositor/Background/BlurEffect.vala"
	actor_dirty = (flags & CLUTTER_EFFECT_PAINT_ACTOR_DIRTY) != 0;
#line 210 "../compositor/Background/BlurEffect.vala"
	if (actor_dirty) {
#line 210 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = TRUE;
#line 899 "BlurEffect.c"
	} else {
#line 210 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = !self->priv->actor_painted;
#line 903 "BlurEffect.c"
	}
#line 210 "../compositor/Background/BlurEffect.vala"
	if (_tmp0_) {
#line 907 "BlurEffect.c"
		ClutterLayerNode* layer_node = NULL;
		CoglFramebuffer* _tmp1_;
		CoglPipeline* _tmp2_;
		ClutterLayerNode* _tmp3_;
		ClutterLayerNode* _tmp4_;
		ClutterLayerNode* _tmp5_;
		ClutterActorBox _tmp6_ = {0};
		graphene_matrix_t transform = {0};
		graphene_matrix_t _tmp7_ = {0};
		ClutterTransformNode* transform_node = NULL;
		graphene_matrix_t _tmp8_;
		ClutterTransformNode* _tmp9_;
		ClutterLayerNode* _tmp10_;
		ClutterTransformNode* _tmp11_;
		ClutterTransformNode* _tmp12_;
#line 212 "../compositor/Background/BlurEffect.vala"
		_tmp1_ = self->priv->actor_framebuffer;
#line 212 "../compositor/Background/BlurEffect.vala"
		_tmp2_ = self->priv->actor_pipeline;
#line 212 "../compositor/Background/BlurEffect.vala"
		_tmp3_ = (ClutterLayerNode*) clutter_layer_node_new_to_framebuffer (_tmp1_, _tmp2_);
#line 212 "../compositor/Background/BlurEffect.vala"
		layer_node = _tmp3_;
#line 213 "../compositor/Background/BlurEffect.vala"
		_tmp4_ = layer_node;
#line 213 "../compositor/Background/BlurEffect.vala"
		clutter_paint_node_add_child (node, (ClutterPaintNode*) _tmp4_);
#line 214 "../compositor/Background/BlurEffect.vala"
		_tmp5_ = layer_node;
#line 214 "../compositor/Background/BlurEffect.vala"
		_tmp6_.x1 = 0.0f;
#line 214 "../compositor/Background/BlurEffect.vala"
		_tmp6_.y1 = 0.0f;
#line 214 "../compositor/Background/BlurEffect.vala"
		_tmp6_.x2 = self->priv->texture_width / self->priv->downscale_factor;
#line 214 "../compositor/Background/BlurEffect.vala"
		_tmp6_.y2 = self->priv->texture_height / self->priv->downscale_factor;
#line 214 "../compositor/Background/BlurEffect.vala"
		clutter_paint_node_add_rectangle ((ClutterPaintNode*) _tmp5_, &_tmp6_);
#line 222 "../compositor/Background/BlurEffect.vala"
		transform = _tmp7_;
#line 223 "../compositor/Background/BlurEffect.vala"
		graphene_matrix_init_scale (&transform, 1.0f / self->priv->downscale_factor, 1.0f / self->priv->downscale_factor, 1.0f);
#line 228 "../compositor/Background/BlurEffect.vala"
		_tmp8_ = transform;
#line 228 "../compositor/Background/BlurEffect.vala"
		_tmp9_ = (ClutterTransformNode*) clutter_transform_node_new (&_tmp8_);
#line 228 "../compositor/Background/BlurEffect.vala"
		transform_node = _tmp9_;
#line 229 "../compositor/Background/BlurEffect.vala"
		_tmp10_ = layer_node;
#line 229 "../compositor/Background/BlurEffect.vala"
		_tmp11_ = transform_node;
#line 229 "../compositor/Background/BlurEffect.vala"
		clutter_paint_node_add_child ((ClutterPaintNode*) _tmp10_, (ClutterPaintNode*) _tmp11_);
#line 232 "../compositor/Background/BlurEffect.vala"
		_tmp12_ = transform_node;
#line 232 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_add_actor_node (self, (ClutterPaintNode*) _tmp12_);
#line 234 "../compositor/Background/BlurEffect.vala"
		self->priv->actor_painted = TRUE;
#line 210 "../compositor/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (transform_node);
#line 210 "../compositor/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (layer_node);
#line 973 "BlurEffect.c"
	} else {
		ClutterPaintNode* pipeline_node = NULL;
		CoglPipeline* _tmp13_;
		ClutterPipelineNode* _tmp14_;
		ClutterPaintNode* _tmp15_;
		ClutterPaintNode* _tmp16_;
		ClutterActorBox _tmp17_ = {0};
#line 236 "../compositor/Background/BlurEffect.vala"
		pipeline_node = NULL;
#line 238 "../compositor/Background/BlurEffect.vala"
		_tmp13_ = self->priv->actor_pipeline;
#line 238 "../compositor/Background/BlurEffect.vala"
		_tmp14_ = (ClutterPipelineNode*) clutter_pipeline_node_new (_tmp13_);
#line 238 "../compositor/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (pipeline_node);
#line 238 "../compositor/Background/BlurEffect.vala"
		pipeline_node = (ClutterPaintNode*) _tmp14_;
#line 239 "../compositor/Background/BlurEffect.vala"
		_tmp15_ = pipeline_node;
#line 239 "../compositor/Background/BlurEffect.vala"
		clutter_paint_node_add_child (node, _tmp15_);
#line 240 "../compositor/Background/BlurEffect.vala"
		_tmp16_ = pipeline_node;
#line 240 "../compositor/Background/BlurEffect.vala"
		_tmp17_.x1 = 0.0f;
#line 240 "../compositor/Background/BlurEffect.vala"
		_tmp17_.y1 = 0.0f;
#line 240 "../compositor/Background/BlurEffect.vala"
		_tmp17_.x2 = self->priv->texture_width / self->priv->downscale_factor;
#line 240 "../compositor/Background/BlurEffect.vala"
		_tmp17_.y2 = self->priv->texture_height / self->priv->downscale_factor;
#line 240 "../compositor/Background/BlurEffect.vala"
		clutter_paint_node_add_rectangle (_tmp16_, &_tmp17_);
#line 210 "../compositor/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (pipeline_node);
#line 1009 "BlurEffect.c"
	}
}

static void
greeter_compositor_blur_effect_add_actor_node (GreeterCompositorBlurEffect* self,
                                               ClutterPaintNode* node)
{
	ClutterActorNode* actor_node = NULL;
	ClutterActor* _tmp0_;
	ClutterActorNode* _tmp1_;
#line 249 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 249 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 250 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 250 "../compositor/Background/BlurEffect.vala"
	_tmp1_ = (ClutterActorNode*) clutter_actor_node_new (_tmp0_, 255);
#line 250 "../compositor/Background/BlurEffect.vala"
	actor_node = _tmp1_;
#line 251 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_child (node, (ClutterPaintNode*) actor_node);
#line 249 "../compositor/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (actor_node);
#line 1034 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_add_blurred_pipeline (GreeterCompositorBlurEffect* self,
                                                     ClutterPaintNode* node)
{
	ClutterPaintNode* pipeline_node = NULL;
	gfloat width = 0.0F;
	gfloat height = 0.0F;
	ClutterActor* _tmp0_;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	CoglPipeline* _tmp3_;
	ClutterPipelineNode* _tmp4_;
	ClutterPaintNode* _tmp5_;
	ClutterPaintNode* _tmp6_;
	ClutterActorBox _tmp7_ = {0};
#line 254 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 254 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 255 "../compositor/Background/BlurEffect.vala"
	pipeline_node = NULL;
#line 261 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 261 "../compositor/Background/BlurEffect.vala"
	clutter_actor_get_size (_tmp0_, &_tmp1_, &_tmp2_);
#line 261 "../compositor/Background/BlurEffect.vala"
	width = _tmp1_;
#line 261 "../compositor/Background/BlurEffect.vala"
	height = _tmp2_;
#line 263 "../compositor/Background/BlurEffect.vala"
	_tmp3_ = self->priv->pipeline;
#line 263 "../compositor/Background/BlurEffect.vala"
	_tmp4_ = (ClutterPipelineNode*) clutter_pipeline_node_new (_tmp3_);
#line 263 "../compositor/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (pipeline_node);
#line 263 "../compositor/Background/BlurEffect.vala"
	pipeline_node = (ClutterPaintNode*) _tmp4_;
#line 264 "../compositor/Background/BlurEffect.vala"
	_tmp5_ = pipeline_node;
#line 264 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_child (node, _tmp5_);
#line 266 "../compositor/Background/BlurEffect.vala"
	_tmp6_ = pipeline_node;
#line 266 "../compositor/Background/BlurEffect.vala"
	_tmp7_.x1 = 0.0f;
#line 266 "../compositor/Background/BlurEffect.vala"
	_tmp7_.y1 = 0.0f;
#line 266 "../compositor/Background/BlurEffect.vala"
	_tmp7_.x2 = width;
#line 266 "../compositor/Background/BlurEffect.vala"
	_tmp7_.y2 = height;
#line 266 "../compositor/Background/BlurEffect.vala"
	clutter_paint_node_add_rectangle (_tmp6_, &_tmp7_);
#line 254 "../compositor/Background/BlurEffect.vala"
	_clutter_paint_node_unref0 (pipeline_node);
#line 1092 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_real_paint_node (ClutterEffect* base,
                                                ClutterPaintNode* node,
                                                ClutterPaintContext* paint_context,
                                                ClutterEffectPaintFlags flags)
{
	GreeterCompositorBlurEffect * self;
	gfloat _tmp0_;
#line 269 "../compositor/Background/BlurEffect.vala"
	self = (GreeterCompositorBlurEffect*) base;
#line 269 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (node != NULL);
#line 269 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (paint_context != NULL);
#line 270 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_radius;
#line 270 "../compositor/Background/BlurEffect.vala"
	if (_tmp0_ <= ((gfloat) 0)) {
#line 272 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_add_actor_node (self, node);
#line 273 "../compositor/Background/BlurEffect.vala"
		return;
#line 1117 "BlurEffect.c"
	}
#line 276 "../compositor/Background/BlurEffect.vala"
	if (greeter_compositor_blur_effect_needs_repaint (self, flags)) {
#line 1121 "BlurEffect.c"
		ClutterActorBox actor_box = {0};
		ClutterActorBox _tmp1_ = {0};
		ClutterActorBox _tmp2_;
		ClutterPaintNode* blur_node = NULL;
		ClutterPaintNode* _tmp3_;
		ClutterPaintNode* _tmp4_;
#line 277 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_update_actor_box (self, paint_context, &_tmp1_);
#line 277 "../compositor/Background/BlurEffect.vala"
		actor_box = _tmp1_;
#line 279 "../compositor/Background/BlurEffect.vala"
		_tmp2_ = actor_box;
#line 279 "../compositor/Background/BlurEffect.vala"
		if (!greeter_compositor_blur_effect_update_framebuffers (self, paint_context, &_tmp2_)) {
#line 281 "../compositor/Background/BlurEffect.vala"
			greeter_compositor_blur_effect_add_actor_node (self, node);
#line 282 "../compositor/Background/BlurEffect.vala"
			return;
#line 1140 "BlurEffect.c"
		}
#line 285 "../compositor/Background/BlurEffect.vala"
		_tmp3_ = greeter_compositor_blur_effect_create_blur_nodes (self, node);
#line 285 "../compositor/Background/BlurEffect.vala"
		blur_node = _tmp3_;
#line 286 "../compositor/Background/BlurEffect.vala"
		_tmp4_ = blur_node;
#line 286 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_paint_actor_offscreen (self, _tmp4_, flags);
#line 276 "../compositor/Background/BlurEffect.vala"
		_clutter_paint_node_unref0 (blur_node);
#line 1152 "BlurEffect.c"
	} else {
#line 289 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_add_blurred_pipeline (self, node);
#line 1156 "BlurEffect.c"
	}
}

ClutterActor*
greeter_compositor_blur_effect_get_actor (GreeterCompositorBlurEffect* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 10 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = self->priv->_actor;
#line 10 "../compositor/Background/BlurEffect.vala"
	result = _tmp0_;
#line 10 "../compositor/Background/BlurEffect.vala"
	return result;
#line 1173 "BlurEffect.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 10 "../compositor/Background/BlurEffect.vala"
	return self ? g_object_ref (self) : NULL;
#line 1181 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_set_actor (GreeterCompositorBlurEffect* self,
                                          ClutterActor* value)
{
	ClutterActor* old_value;
#line 10 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 10 "../compositor/Background/BlurEffect.vala"
	old_value = greeter_compositor_blur_effect_get_actor (self);
#line 10 "../compositor/Background/BlurEffect.vala"
	if (old_value != value) {
#line 1195 "BlurEffect.c"
		ClutterActor* _tmp0_;
#line 10 "../compositor/Background/BlurEffect.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 10 "../compositor/Background/BlurEffect.vala"
		_g_object_unref0 (self->priv->_actor);
#line 10 "../compositor/Background/BlurEffect.vala"
		self->priv->_actor = _tmp0_;
#line 10 "../compositor/Background/BlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_compositor_blur_effect_properties[GREETER_COMPOSITOR_BLUR_EFFECT_ACTOR_PROPERTY]);
#line 1205 "BlurEffect.c"
	}
}

gfloat
greeter_compositor_blur_effect_get_radius (GreeterCompositorBlurEffect* self)
{
	gfloat result;
#line 11 "../compositor/Background/BlurEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 11 "../compositor/Background/BlurEffect.vala"
	result = self->priv->_radius;
#line 11 "../compositor/Background/BlurEffect.vala"
	return result;
#line 1219 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_set_radius (GreeterCompositorBlurEffect* self,
                                           gfloat value)
{
	gfloat old_value;
#line 11 "../compositor/Background/BlurEffect.vala"
	g_return_if_fail (self != NULL);
#line 11 "../compositor/Background/BlurEffect.vala"
	old_value = greeter_compositor_blur_effect_get_radius (self);
#line 11 "../compositor/Background/BlurEffect.vala"
	if (old_value != value) {
#line 11 "../compositor/Background/BlurEffect.vala"
		self->priv->_radius = value;
#line 11 "../compositor/Background/BlurEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_compositor_blur_effect_properties[GREETER_COMPOSITOR_BLUR_EFFECT_RADIUS_PROPERTY]);
#line 1237 "BlurEffect.c"
	}
}

static GObject *
greeter_compositor_blur_effect_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GreeterCompositorBlurEffect * self;
	CoglContext* ctx = NULL;
	ClutterBackend* _tmp0_;
	CoglContext* _tmp1_;
	CoglContext* _tmp2_;
	CoglPipeline* _tmp3_;
	CoglPipeline* _tmp4_;
	CoglPipeline* _tmp5_;
	CoglPipeline* _tmp6_;
	CoglContext* _tmp7_;
	CoglPipeline* _tmp8_;
	CoglPipeline* _tmp9_;
	CoglPipeline* _tmp10_;
	CoglPipeline* _tmp11_;
#line 31 "../compositor/Background/BlurEffect.vala"
	parent_class = G_OBJECT_CLASS (greeter_compositor_blur_effect_parent_class);
#line 31 "../compositor/Background/BlurEffect.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../compositor/Background/BlurEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffect);
#line 32 "../compositor/Background/BlurEffect.vala"
	_tmp0_ = clutter_get_default_backend ();
#line 32 "../compositor/Background/BlurEffect.vala"
	_tmp1_ = clutter_backend_get_cogl_context (_tmp0_);
#line 32 "../compositor/Background/BlurEffect.vala"
	ctx = _tmp1_;
#line 34 "../compositor/Background/BlurEffect.vala"
	_tmp2_ = ctx;
#line 34 "../compositor/Background/BlurEffect.vala"
	_tmp3_ = cogl_pipeline_new (_tmp2_);
#line 34 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_pipeline);
#line 34 "../compositor/Background/BlurEffect.vala"
	self->priv->actor_pipeline = _tmp3_;
#line 35 "../compositor/Background/BlurEffect.vala"
	_tmp4_ = self->priv->actor_pipeline;
#line 35 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_null_texture (_tmp4_, 0);
#line 36 "../compositor/Background/BlurEffect.vala"
	_tmp5_ = self->priv->actor_pipeline;
#line 36 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_filters (_tmp5_, 0, COGL_PIPELINE_FILTER_LINEAR, COGL_PIPELINE_FILTER_LINEAR);
#line 37 "../compositor/Background/BlurEffect.vala"
	_tmp6_ = self->priv->actor_pipeline;
#line 37 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_wrap_mode (_tmp6_, 0, COGL_PIPELINE_WRAP_MODE_CLAMP_TO_EDGE);
#line 39 "../compositor/Background/BlurEffect.vala"
	_tmp7_ = ctx;
#line 39 "../compositor/Background/BlurEffect.vala"
	_tmp8_ = cogl_pipeline_new (_tmp7_);
#line 39 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 39 "../compositor/Background/BlurEffect.vala"
	self->priv->pipeline = _tmp8_;
#line 40 "../compositor/Background/BlurEffect.vala"
	_tmp9_ = self->priv->pipeline;
#line 40 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_null_texture (_tmp9_, 0);
#line 41 "../compositor/Background/BlurEffect.vala"
	_tmp10_ = self->priv->pipeline;
#line 41 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_filters (_tmp10_, 0, COGL_PIPELINE_FILTER_LINEAR, COGL_PIPELINE_FILTER_LINEAR);
#line 42 "../compositor/Background/BlurEffect.vala"
	_tmp11_ = self->priv->pipeline;
#line 42 "../compositor/Background/BlurEffect.vala"
	cogl_pipeline_set_layer_wrap_mode (_tmp11_, 0, COGL_PIPELINE_WRAP_MODE_CLAMP_TO_EDGE);
#line 31 "../compositor/Background/BlurEffect.vala"
	return obj;
#line 1316 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_class_init (GreeterCompositorBlurEffectClass * klass,
                                           gpointer klass_data)
{
#line 6 "../compositor/Background/BlurEffect.vala"
	greeter_compositor_blur_effect_parent_class = g_type_class_peek_parent (klass);
#line 6 "../compositor/Background/BlurEffect.vala"
	g_type_class_adjust_private_offset (klass, &GreeterCompositorBlurEffect_private_offset);
#line 6 "../compositor/Background/BlurEffect.vala"
	((ClutterEffectClass *) klass)->paint_node = (void (*) (ClutterEffect*, ClutterPaintNode*, ClutterPaintContext*, ClutterEffectPaintFlags)) greeter_compositor_blur_effect_real_paint_node;
#line 6 "../compositor/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_greeter_compositor_blur_effect_get_property;
#line 6 "../compositor/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_greeter_compositor_blur_effect_set_property;
#line 6 "../compositor/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->constructor = greeter_compositor_blur_effect_constructor;
#line 6 "../compositor/Background/BlurEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = greeter_compositor_blur_effect_finalize;
#line 6 "../compositor/Background/BlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_COMPOSITOR_BLUR_EFFECT_ACTOR_PROPERTY, greeter_compositor_blur_effect_properties[GREETER_COMPOSITOR_BLUR_EFFECT_ACTOR_PROPERTY] = g_param_spec_object ("actor", "actor", "actor", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../compositor/Background/BlurEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_COMPOSITOR_BLUR_EFFECT_RADIUS_PROPERTY, greeter_compositor_blur_effect_properties[GREETER_COMPOSITOR_BLUR_EFFECT_RADIUS_PROPERTY] = g_param_spec_float ("radius", "radius", "radius", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1341 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_instance_init (GreeterCompositorBlurEffect * self,
                                              gpointer klass)
{
#line 6 "../compositor/Background/BlurEffect.vala"
	self->priv = greeter_compositor_blur_effect_get_instance_private (self);
#line 13 "../compositor/Background/BlurEffect.vala"
	self->priv->actor_painted = FALSE;
#line 14 "../compositor/Background/BlurEffect.vala"
	self->priv->blur_applied = FALSE;
#line 1354 "BlurEffect.c"
}

static void
greeter_compositor_blur_effect_finalize (GObject * obj)
{
	GreeterCompositorBlurEffect * self;
#line 6 "../compositor/Background/BlurEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffect);
#line 10 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->_actor);
#line 19 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_framebuffer);
#line 20 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_pipeline);
#line 21 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->actor_texture);
#line 23 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->framebuffer);
#line 24 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 25 "../compositor/Background/BlurEffect.vala"
	_g_object_unref0 (self->priv->texture);
#line 6 "../compositor/Background/BlurEffect.vala"
	G_OBJECT_CLASS (greeter_compositor_blur_effect_parent_class)->finalize (obj);
#line 1379 "BlurEffect.c"
}

static GType
greeter_compositor_blur_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GreeterCompositorBlurEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_compositor_blur_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterCompositorBlurEffect), 0, (GInstanceInitFunc) greeter_compositor_blur_effect_instance_init, NULL };
	GType greeter_compositor_blur_effect_type_id;
	greeter_compositor_blur_effect_type_id = g_type_register_static (clutter_effect_get_type (), "GreeterCompositorBlurEffect", &g_define_type_info, 0);
	GreeterCompositorBlurEffect_private_offset = g_type_add_instance_private (greeter_compositor_blur_effect_type_id, sizeof (GreeterCompositorBlurEffectPrivate));
	return greeter_compositor_blur_effect_type_id;
}

GType
greeter_compositor_blur_effect_get_type (void)
{
	static volatile gsize greeter_compositor_blur_effect_type_id__once = 0;
	if (g_once_init_enter (&greeter_compositor_blur_effect_type_id__once)) {
		GType greeter_compositor_blur_effect_type_id;
		greeter_compositor_blur_effect_type_id = greeter_compositor_blur_effect_get_type_once ();
		g_once_init_leave (&greeter_compositor_blur_effect_type_id__once, greeter_compositor_blur_effect_type_id);
	}
	return greeter_compositor_blur_effect_type_id__once;
}

static void
_vala_greeter_compositor_blur_effect_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GreeterCompositorBlurEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffect);
#line 6 "../compositor/Background/BlurEffect.vala"
	switch (property_id) {
#line 6 "../compositor/Background/BlurEffect.vala"
		case GREETER_COMPOSITOR_BLUR_EFFECT_ACTOR_PROPERTY:
#line 6 "../compositor/Background/BlurEffect.vala"
		g_value_set_object (value, greeter_compositor_blur_effect_get_actor (self));
#line 6 "../compositor/Background/BlurEffect.vala"
		break;
#line 6 "../compositor/Background/BlurEffect.vala"
		case GREETER_COMPOSITOR_BLUR_EFFECT_RADIUS_PROPERTY:
#line 6 "../compositor/Background/BlurEffect.vala"
		g_value_set_float (value, greeter_compositor_blur_effect_get_radius (self));
#line 6 "../compositor/Background/BlurEffect.vala"
		break;
#line 1426 "BlurEffect.c"
		default:
#line 6 "../compositor/Background/BlurEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../compositor/Background/BlurEffect.vala"
		break;
#line 1432 "BlurEffect.c"
	}
}

static void
_vala_greeter_compositor_blur_effect_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GreeterCompositorBlurEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GREETER_COMPOSITOR_TYPE_BLUR_EFFECT, GreeterCompositorBlurEffect);
#line 6 "../compositor/Background/BlurEffect.vala"
	switch (property_id) {
#line 6 "../compositor/Background/BlurEffect.vala"
		case GREETER_COMPOSITOR_BLUR_EFFECT_ACTOR_PROPERTY:
#line 6 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_set_actor (self, g_value_get_object (value));
#line 6 "../compositor/Background/BlurEffect.vala"
		break;
#line 6 "../compositor/Background/BlurEffect.vala"
		case GREETER_COMPOSITOR_BLUR_EFFECT_RADIUS_PROPERTY:
#line 6 "../compositor/Background/BlurEffect.vala"
		greeter_compositor_blur_effect_set_radius (self, g_value_get_float (value));
#line 6 "../compositor/Background/BlurEffect.vala"
		break;
#line 1458 "BlurEffect.c"
		default:
#line 6 "../compositor/Background/BlurEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../compositor/Background/BlurEffect.vala"
		break;
#line 1464 "BlurEffect.c"
	}
}

