/* Utils.c generated by valac 0.56.18, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright 2012 Tom Beckmann, Rico Tzschichholz
 * Copyright 2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <meta/workspace.h>
#include <meta/window.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_COMPOSITOR_TYPE_UTILS (greeter_compositor_utils_get_type ())
#define GREETER_COMPOSITOR_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_UTILS, GreeterCompositorUtils))
#define GREETER_COMPOSITOR_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_UTILS, GreeterCompositorUtilsClass))
#define GREETER_COMPOSITOR_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_UTILS))
#define GREETER_COMPOSITOR_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_UTILS))
#define GREETER_COMPOSITOR_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_UTILS, GreeterCompositorUtilsClass))

typedef struct _GreeterCompositorUtils GreeterCompositorUtils;
typedef struct _GreeterCompositorUtilsClass GreeterCompositorUtilsClass;
typedef struct _GreeterCompositorUtilsPrivate GreeterCompositorUtilsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _GreeterCompositorParamSpecUtils GreeterCompositorParamSpecUtils;

struct _GreeterCompositorUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GreeterCompositorUtilsPrivate * priv;
};

struct _GreeterCompositorUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (GreeterCompositorUtils *self);
};

struct _GreeterCompositorParamSpecUtils {
	GParamSpec parent_instance;
};

static gpointer greeter_compositor_utils_parent_class = NULL;
static GHashTable* greeter_compositor_utils_icon_pixbuf_cache;
static GHashTable* greeter_compositor_utils_icon_pixbuf_cache = NULL;
static GtkStyleContext* greeter_compositor_utils_selection_style_context;
static GtkStyleContext* greeter_compositor_utils_selection_style_context = NULL;

VALA_EXTERN gpointer greeter_compositor_utils_ref (gpointer instance);
VALA_EXTERN void greeter_compositor_utils_unref (gpointer instance);
VALA_EXTERN GParamSpec* greeter_compositor_param_spec_utils (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags);
VALA_EXTERN void greeter_compositor_value_set_utils (GValue* value,
                                         gpointer v_object);
VALA_EXTERN void greeter_compositor_value_take_utils (GValue* value,
                                          gpointer v_object);
VALA_EXTERN gpointer greeter_compositor_value_get_utils (const GValue* value);
VALA_EXTERN GType greeter_compositor_utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorUtils, greeter_compositor_utils_unref)
VALA_EXTERN guint greeter_compositor_utils_get_n_windows (MetaWorkspace* workspace);
VALA_EXTERN gint greeter_compositor_utils_scale_to_int (gint value,
                                            gfloat scale_factor);
VALA_EXTERN void greeter_compositor_utils_get_theme_accent_color (GdkRGBA* result);
VALA_EXTERN GreeterCompositorUtils* greeter_compositor_utils_new (void);
VALA_EXTERN GreeterCompositorUtils* greeter_compositor_utils_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void greeter_compositor_utils_finalize (GreeterCompositorUtils * obj);
static GType greeter_compositor_utils_get_type_once (void);

/**
         * Get the number of toplevel windows on a workspace excluding those that are
         * on all workspaces
         *
         * @param workspace The workspace on which to count the windows
         */
guint
greeter_compositor_utils_get_n_windows (MetaWorkspace* workspace)
{
	gint n = 0;
	GList* _tmp0_;
	guint result;
#line 33 "../compositor/Utils.vala"
	g_return_val_if_fail (workspace != NULL, 0U);
#line 34 "../compositor/Utils.vala"
	n = 0;
#line 35 "../compositor/Utils.vala"
	_tmp0_ = meta_workspace_list_windows (workspace);
#line 133 "Utils.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 35 "../compositor/Utils.vala"
		window_collection = _tmp0_;
#line 35 "../compositor/Utils.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 141 "Utils.c"
			MetaWindow* window = NULL;
#line 35 "../compositor/Utils.vala"
			window = (MetaWindow*) window_it->data;
#line 145 "Utils.c"
			{
				MetaWindow* _tmp1_;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				MetaWindow* _tmp4_;
				MetaWindowType _tmp5_;
				MetaWindowType _tmp6_;
#line 36 "../compositor/Utils.vala"
				_tmp1_ = window;
#line 36 "../compositor/Utils.vala"
				if (meta_window_is_on_all_workspaces (_tmp1_)) {
#line 37 "../compositor/Utils.vala"
					continue;
#line 159 "Utils.c"
				}
#line 39 "../compositor/Utils.vala"
				_tmp4_ = window;
#line 39 "../compositor/Utils.vala"
				_tmp5_ = meta_window_get_window_type (_tmp4_);
#line 39 "../compositor/Utils.vala"
				_tmp6_ = _tmp5_;
#line 39 "../compositor/Utils.vala"
				if (_tmp6_ == META_WINDOW_NORMAL) {
#line 39 "../compositor/Utils.vala"
					_tmp3_ = TRUE;
#line 171 "Utils.c"
				} else {
					MetaWindow* _tmp7_;
					MetaWindowType _tmp8_;
					MetaWindowType _tmp9_;
#line 40 "../compositor/Utils.vala"
					_tmp7_ = window;
#line 40 "../compositor/Utils.vala"
					_tmp8_ = meta_window_get_window_type (_tmp7_);
#line 40 "../compositor/Utils.vala"
					_tmp9_ = _tmp8_;
#line 40 "../compositor/Utils.vala"
					_tmp3_ = _tmp9_ == META_WINDOW_DIALOG;
#line 184 "Utils.c"
				}
#line 39 "../compositor/Utils.vala"
				if (_tmp3_) {
#line 39 "../compositor/Utils.vala"
					_tmp2_ = TRUE;
#line 190 "Utils.c"
				} else {
					MetaWindow* _tmp10_;
					MetaWindowType _tmp11_;
					MetaWindowType _tmp12_;
#line 41 "../compositor/Utils.vala"
					_tmp10_ = window;
#line 41 "../compositor/Utils.vala"
					_tmp11_ = meta_window_get_window_type (_tmp10_);
#line 41 "../compositor/Utils.vala"
					_tmp12_ = _tmp11_;
#line 41 "../compositor/Utils.vala"
					_tmp2_ = _tmp12_ == META_WINDOW_MODAL_DIALOG;
#line 203 "Utils.c"
				}
#line 39 "../compositor/Utils.vala"
				if (_tmp2_) {
#line 207 "Utils.c"
					gint _tmp13_;
#line 42 "../compositor/Utils.vala"
					_tmp13_ = n;
#line 42 "../compositor/Utils.vala"
					n = _tmp13_ + 1;
#line 213 "Utils.c"
				}
			}
		}
#line 35 "../compositor/Utils.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 219 "Utils.c"
	}
#line 45 "../compositor/Utils.vala"
	result = (guint) n;
#line 45 "../compositor/Utils.vala"
	return result;
#line 225 "Utils.c"
}

/**
         * Multiplies an integer by a floating scaling factor, and then
         * returns the result rounded to the nearest integer
         */
gint
greeter_compositor_utils_scale_to_int (gint value,
                                       gfloat scale_factor)
{
	gint result;
#line 53 "../compositor/Utils.vala"
	result = (gint) round ((gdouble) (((gfloat) value) * scale_factor));
#line 53 "../compositor/Utils.vala"
	return result;
#line 241 "Utils.c"
}

void
greeter_compositor_utils_get_theme_accent_color (GdkRGBA* result)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp7_;
	GValue _tmp8_ = {0};
	GValue _tmp9_;
	GdkRGBA* _tmp10_;
	GdkRGBA _tmp11_ = {0};
	GdkRGBA _tmp12_;
#line 58 "../compositor/Utils.vala"
	_tmp0_ = greeter_compositor_utils_selection_style_context;
#line 58 "../compositor/Utils.vala"
	if (_tmp0_ == NULL) {
#line 258 "Utils.c"
		GtkWidgetPath* label_widget_path = NULL;
		GtkWidgetPath* _tmp1_;
		GtkWidgetPath* _tmp2_;
		GtkWidgetPath* _tmp3_;
		GtkStyleContext* _tmp4_;
		GtkStyleContext* _tmp5_;
		GtkWidgetPath* _tmp6_;
#line 59 "../compositor/Utils.vala"
		_tmp1_ = gtk_widget_path_new ();
#line 59 "../compositor/Utils.vala"
		label_widget_path = _tmp1_;
#line 60 "../compositor/Utils.vala"
		_tmp2_ = label_widget_path;
#line 60 "../compositor/Utils.vala"
		gtk_widget_path_append_type (_tmp2_, g_type_from_name ("label"));
#line 61 "../compositor/Utils.vala"
		_tmp3_ = label_widget_path;
#line 61 "../compositor/Utils.vala"
		gtk_widget_path_iter_set_object_name (_tmp3_, -1, "selection");
#line 63 "../compositor/Utils.vala"
		_tmp4_ = gtk_style_context_new ();
#line 63 "../compositor/Utils.vala"
		_g_object_unref0 (greeter_compositor_utils_selection_style_context);
#line 63 "../compositor/Utils.vala"
		greeter_compositor_utils_selection_style_context = _tmp4_;
#line 64 "../compositor/Utils.vala"
		_tmp5_ = greeter_compositor_utils_selection_style_context;
#line 64 "../compositor/Utils.vala"
		_tmp6_ = label_widget_path;
#line 64 "../compositor/Utils.vala"
		gtk_style_context_set_path (_tmp5_, _tmp6_);
#line 58 "../compositor/Utils.vala"
		_gtk_widget_path_unref0 (label_widget_path);
#line 292 "Utils.c"
	}
#line 67 "../compositor/Utils.vala"
	_tmp7_ = greeter_compositor_utils_selection_style_context;
#line 67 "../compositor/Utils.vala"
	gtk_style_context_get_property (_tmp7_, GTK_STYLE_PROPERTY_BACKGROUND_COLOR, GTK_STATE_FLAG_NORMAL, &_tmp8_);
#line 67 "../compositor/Utils.vala"
	_tmp9_ = _tmp8_;
#line 67 "../compositor/Utils.vala"
	_tmp10_ = g_value_get_boxed (&_tmp8_);
#line 67 "../compositor/Utils.vala"
	_tmp12_ = (G_VALUE_HOLDS (&_tmp8_, gdk_rgba_get_type ()) && _tmp10_) ? (*_tmp10_) : (g_warning ("Invalid GValue unboxing (wrong type or NULL)"), _tmp11_);
#line 67 "../compositor/Utils.vala"
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 67 "../compositor/Utils.vala"
	*result = _tmp12_;
#line 67 "../compositor/Utils.vala"
	return;
#line 310 "Utils.c"
}

GreeterCompositorUtils*
greeter_compositor_utils_construct (GType object_type)
{
	GreeterCompositorUtils* self = NULL;
#line 20 "../compositor/Utils.vala"
	self = (GreeterCompositorUtils*) g_type_create_instance (object_type);
#line 20 "../compositor/Utils.vala"
	return self;
#line 321 "Utils.c"
}

GreeterCompositorUtils*
greeter_compositor_utils_new (void)
{
#line 20 "../compositor/Utils.vala"
	return greeter_compositor_utils_construct (GREETER_COMPOSITOR_TYPE_UTILS);
#line 329 "Utils.c"
}

static void
_g_free0_ (gpointer var)
{
#line 24 "../compositor/Utils.vala"
	var = (g_free (var), NULL);
#line 337 "Utils.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 24 "../compositor/Utils.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 345 "Utils.c"
}

static void
greeter_compositor_value_utils_init (GValue* value)
{
#line 20 "../compositor/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 353 "Utils.c"
}

static void
greeter_compositor_value_utils_free_value (GValue* value)
{
#line 20 "../compositor/Utils.vala"
	if (value->data[0].v_pointer) {
#line 20 "../compositor/Utils.vala"
		greeter_compositor_utils_unref (value->data[0].v_pointer);
#line 363 "Utils.c"
	}
}

static void
greeter_compositor_value_utils_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 20 "../compositor/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../compositor/Utils.vala"
		dest_value->data[0].v_pointer = greeter_compositor_utils_ref (src_value->data[0].v_pointer);
#line 375 "Utils.c"
	} else {
#line 20 "../compositor/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 379 "Utils.c"
	}
}

static gpointer
greeter_compositor_value_utils_peek_pointer (const GValue* value)
{
#line 20 "../compositor/Utils.vala"
	return value->data[0].v_pointer;
#line 388 "Utils.c"
}

static gchar*
greeter_compositor_value_utils_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 20 "../compositor/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 399 "Utils.c"
		GreeterCompositorUtils * object;
		object = collect_values[0].v_pointer;
#line 20 "../compositor/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../compositor/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 406 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../compositor/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 410 "Utils.c"
		}
#line 20 "../compositor/Utils.vala"
		value->data[0].v_pointer = greeter_compositor_utils_ref (object);
#line 414 "Utils.c"
	} else {
#line 20 "../compositor/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 418 "Utils.c"
	}
#line 20 "../compositor/Utils.vala"
	return NULL;
#line 422 "Utils.c"
}

static gchar*
greeter_compositor_value_utils_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	GreeterCompositorUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../compositor/Utils.vala"
	if (!object_p) {
#line 20 "../compositor/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 437 "Utils.c"
	}
#line 20 "../compositor/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../compositor/Utils.vala"
		*object_p = NULL;
#line 443 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../compositor/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 447 "Utils.c"
	} else {
#line 20 "../compositor/Utils.vala"
		*object_p = greeter_compositor_utils_ref (value->data[0].v_pointer);
#line 451 "Utils.c"
	}
#line 20 "../compositor/Utils.vala"
	return NULL;
#line 455 "Utils.c"
}

GParamSpec*
greeter_compositor_param_spec_utils (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	GreeterCompositorParamSpecUtils* spec;
#line 20 "../compositor/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GREETER_COMPOSITOR_TYPE_UTILS), NULL);
#line 20 "../compositor/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../compositor/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../compositor/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 474 "Utils.c"
}

gpointer
greeter_compositor_value_get_utils (const GValue* value)
{
#line 20 "../compositor/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GREETER_COMPOSITOR_TYPE_UTILS), NULL);
#line 20 "../compositor/Utils.vala"
	return value->data[0].v_pointer;
#line 484 "Utils.c"
}

void
greeter_compositor_value_set_utils (GValue* value,
                                    gpointer v_object)
{
	GreeterCompositorUtils * old;
#line 20 "../compositor/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GREETER_COMPOSITOR_TYPE_UTILS));
#line 20 "../compositor/Utils.vala"
	old = value->data[0].v_pointer;
#line 20 "../compositor/Utils.vala"
	if (v_object) {
#line 20 "../compositor/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GREETER_COMPOSITOR_TYPE_UTILS));
#line 20 "../compositor/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../compositor/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../compositor/Utils.vala"
		greeter_compositor_utils_ref (value->data[0].v_pointer);
#line 506 "Utils.c"
	} else {
#line 20 "../compositor/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 510 "Utils.c"
	}
#line 20 "../compositor/Utils.vala"
	if (old) {
#line 20 "../compositor/Utils.vala"
		greeter_compositor_utils_unref (old);
#line 516 "Utils.c"
	}
}

void
greeter_compositor_value_take_utils (GValue* value,
                                     gpointer v_object)
{
	GreeterCompositorUtils * old;
#line 20 "../compositor/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GREETER_COMPOSITOR_TYPE_UTILS));
#line 20 "../compositor/Utils.vala"
	old = value->data[0].v_pointer;
#line 20 "../compositor/Utils.vala"
	if (v_object) {
#line 20 "../compositor/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GREETER_COMPOSITOR_TYPE_UTILS));
#line 20 "../compositor/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../compositor/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 537 "Utils.c"
	} else {
#line 20 "../compositor/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 541 "Utils.c"
	}
#line 20 "../compositor/Utils.vala"
	if (old) {
#line 20 "../compositor/Utils.vala"
		greeter_compositor_utils_unref (old);
#line 547 "Utils.c"
	}
}

static void
greeter_compositor_utils_base_init (GreeterCompositorUtilsClass * klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 24 "../compositor/Utils.vala"
	_tmp0_ = g_str_hash;
#line 24 "../compositor/Utils.vala"
	_tmp1_ = g_str_equal;
#line 24 "../compositor/Utils.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 24 "../compositor/Utils.vala"
	_g_hash_table_unref0 (greeter_compositor_utils_icon_pixbuf_cache);
#line 24 "../compositor/Utils.vala"
	greeter_compositor_utils_icon_pixbuf_cache = _tmp2_;
#line 567 "Utils.c"
}

static void
greeter_compositor_utils_class_init (GreeterCompositorUtilsClass * klass,
                                     gpointer klass_data)
{
#line 20 "../compositor/Utils.vala"
	greeter_compositor_utils_parent_class = g_type_class_peek_parent (klass);
#line 20 "../compositor/Utils.vala"
	((GreeterCompositorUtilsClass *) klass)->finalize = greeter_compositor_utils_finalize;
#line 578 "Utils.c"
}

static void
greeter_compositor_utils_instance_init (GreeterCompositorUtils * self,
                                        gpointer klass)
{
#line 20 "../compositor/Utils.vala"
	self->ref_count = 1;
#line 587 "Utils.c"
}

static void
greeter_compositor_utils_finalize (GreeterCompositorUtils * obj)
{
	GreeterCompositorUtils * self;
#line 20 "../compositor/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_COMPOSITOR_TYPE_UTILS, GreeterCompositorUtils);
#line 20 "../compositor/Utils.vala"
	g_signal_handlers_destroy (self);
#line 598 "Utils.c"
}

static GType
greeter_compositor_utils_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { greeter_compositor_value_utils_init, greeter_compositor_value_utils_free_value, greeter_compositor_value_utils_copy_value, greeter_compositor_value_utils_peek_pointer, "p", greeter_compositor_value_utils_collect_value, "p", greeter_compositor_value_utils_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GreeterCompositorUtilsClass), (GBaseInitFunc) greeter_compositor_utils_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_compositor_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterCompositorUtils), 0, (GInstanceInitFunc) greeter_compositor_utils_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType greeter_compositor_utils_type_id;
	greeter_compositor_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GreeterCompositorUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return greeter_compositor_utils_type_id;
}

GType
greeter_compositor_utils_get_type (void)
{
	static volatile gsize greeter_compositor_utils_type_id__once = 0;
	if (g_once_init_enter (&greeter_compositor_utils_type_id__once)) {
		GType greeter_compositor_utils_type_id;
		greeter_compositor_utils_type_id = greeter_compositor_utils_get_type_once ();
		g_once_init_leave (&greeter_compositor_utils_type_id__once, greeter_compositor_utils_type_id);
	}
	return greeter_compositor_utils_type_id__once;
}

gpointer
greeter_compositor_utils_ref (gpointer instance)
{
	GreeterCompositorUtils * self;
	self = instance;
#line 20 "../compositor/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../compositor/Utils.vala"
	return instance;
#line 633 "Utils.c"
}

void
greeter_compositor_utils_unref (gpointer instance)
{
	GreeterCompositorUtils * self;
	self = instance;
#line 20 "../compositor/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../compositor/Utils.vala"
		GREETER_COMPOSITOR_UTILS_GET_CLASS (self)->finalize (self);
#line 20 "../compositor/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 647 "Utils.c"
	}
}

