/* Application.c generated by valac 0.56.18, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright 2018-2024 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authors: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <lightdm.h>
#include <gio/gio.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define CONSTANTS_GETTEXT_PACKAGE "io.elementary.greeter"
#define CONSTANTS_LOCALE_DIR "/usr/share/locale"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_TYPE_APPLICATION (greeter_application_get_type ())
#define GREETER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_APPLICATION, GreeterApplication))
#define GREETER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_APPLICATION, GreeterApplicationClass))
#define GREETER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_APPLICATION))
#define GREETER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_APPLICATION))
#define GREETER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_APPLICATION, GreeterApplicationClass))

typedef struct _GreeterApplication GreeterApplication;
typedef struct _GreeterApplicationClass GreeterApplicationClass;
typedef struct _GreeterApplicationPrivate GreeterApplicationPrivate;
enum  {
	GREETER_APPLICATION_0_PROPERTY,
	GREETER_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* greeter_application_properties[GREETER_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GREETER_TYPE_SETTINGS_PORTAL (greeter_settings_portal_get_type ())
#define GREETER_SETTINGS_PORTAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_SETTINGS_PORTAL, GreeterSettingsPortal))
#define GREETER_SETTINGS_PORTAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_SETTINGS_PORTAL, GreeterSettingsPortalClass))
#define GREETER_IS_SETTINGS_PORTAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_SETTINGS_PORTAL))
#define GREETER_IS_SETTINGS_PORTAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_SETTINGS_PORTAL))
#define GREETER_SETTINGS_PORTAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_SETTINGS_PORTAL, GreeterSettingsPortalClass))

typedef struct _GreeterSettingsPortal GreeterSettingsPortal;
typedef struct _GreeterSettingsPortalClass GreeterSettingsPortalClass;
typedef struct _Block1Data Block1Data;
#define _g_variant_dict_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_dict_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define GREETER_TYPE_MAIN_WINDOW (greeter_main_window_get_type ())
#define GREETER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_MAIN_WINDOW, GreeterMainWindow))
#define GREETER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_MAIN_WINDOW, GreeterMainWindowClass))
#define GREETER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_MAIN_WINDOW))
#define GREETER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_MAIN_WINDOW))
#define GREETER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_MAIN_WINDOW, GreeterMainWindowClass))

typedef struct _GreeterMainWindow GreeterMainWindow;
typedef struct _GreeterMainWindowClass GreeterMainWindowClass;

struct _GreeterApplication {
	GtkApplication parent_instance;
	GreeterApplicationPrivate * priv;
};

struct _GreeterApplicationClass {
	GtkApplicationClass parent_class;
};

struct _GreeterApplicationPrivate {
	LightDMGreeter* lightdm_greeter;
};

struct _Block1Data {
	int _ref_count_;
	GreeterApplication* self;
	GtkSettings* gtk_settings;
	GreeterSettingsPortal* settings_portal;
	GSimpleAction* select_session_action;
	GVariantDict* vardict;
};

static gint GreeterApplication_private_offset;
static gpointer greeter_application_parent_class = NULL;

VALA_EXTERN GType greeter_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterApplication, g_object_unref)
VALA_EXTERN GreeterApplication* greeter_application_new (void);
VALA_EXTERN GreeterApplication* greeter_application_construct (GType object_type);
static void greeter_application_real_startup (GApplication* base);
VALA_EXTERN GType greeter_settings_portal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterSettingsPortal, g_object_unref)
VALA_EXTERN guint greeter_settings_portal_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (GreeterApplication* self,
                 GDBusConnection* connection,
                 const gchar* name);
VALA_EXTERN GreeterSettingsPortal* greeter_settings_portal_get_default (void);
static void ___lambda4__gbus_acquired_callback (GDBusConnection* connection,
                                         const gchar* name,
                                         gpointer self);
static void __lambda6_ (GreeterApplication* self);
static void ___lambda6__gbus_name_acquired_callback (GDBusConnection* connection,
                                              const gchar* name,
                                              gpointer self);
static void __lambda7_ (GreeterApplication* self);
static void ___lambda7__gbus_name_lost_callback (GDBusConnection* connection,
                                          const gchar* name,
                                          gpointer self);
VALA_EXTERN gint greeter_settings_portal_get_prefers_color_scheme (GreeterSettingsPortal* self);
static void __lambda8_ (Block1Data* _data1_);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GVariant* _variant_new1 (const gchar* value);
static void __lambda9_ (Block1Data* _data1_,
                 LightDMSession* session);
static void ___lambda9__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda10_ (Block1Data* _data1_,
                  GVariant* param);
static void ___lambda10__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static void greeter_application_real_activate (GApplication* base);
VALA_EXTERN GreeterMainWindow* greeter_main_window_new (LightDMGreeter* lightdm_greeter);
VALA_EXTERN GreeterMainWindow* greeter_main_window_construct (GType object_type,
                                                  LightDMGreeter* lightdm_greeter);
VALA_EXTERN GType greeter_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterMainWindow, g_object_unref)
static gint greeter_application_main (gchar** args,
                               gint args_length1);
static GObject * greeter_application_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void greeter_application_finalize (GObject * obj);
static GType greeter_application_get_type_once (void);

static inline gpointer
greeter_application_get_instance_private (GreeterApplication* self)
{
	return G_STRUCT_MEMBER_P (self, GreeterApplication_private_offset);
}

GreeterApplication*
greeter_application_construct (GType object_type)
{
	GreeterApplication * self = NULL;
#line 26 "../src/Application.vala"
	self = (GreeterApplication*) g_object_new (object_type, "application-id", "io.elementary.greeter", "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 25 "../src/Application.vala"
	return self;
#line 195 "Application.c"
}

GreeterApplication*
greeter_application_new (void)
{
#line 25 "../src/Application.vala"
	return greeter_application_construct (GREETER_TYPE_APPLICATION);
#line 203 "Application.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 39 "../src/Application.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 39 "../src/Application.vala"
	return _data1_;
#line 213 "Application.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 39 "../src/Application.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 223 "Application.c"
		GreeterApplication* self;
#line 39 "../src/Application.vala"
		self = _data1_->self;
#line 39 "../src/Application.vala"
		_g_variant_dict_unref0 (_data1_->vardict);
#line 39 "../src/Application.vala"
		_g_object_unref0 (_data1_->select_session_action);
#line 39 "../src/Application.vala"
		_g_object_unref0 (self);
#line 39 "../src/Application.vala"
		g_slice_free (Block1Data, _data1_);
#line 235 "Application.c"
	}
}

static void
__lambda4_ (GreeterApplication* self,
            GDBusConnection* connection,
            const gchar* name)
{
	GError* _inner_error0_ = NULL;
#line 51 "../src/Application.vala"
	g_return_if_fail (connection != NULL);
#line 51 "../src/Application.vala"
	g_return_if_fail (name != NULL);
#line 249 "Application.c"
	{
		GreeterSettingsPortal* _tmp0_;
#line 53 "../src/Application.vala"
		_tmp0_ = greeter_settings_portal_get_default ();
#line 53 "../src/Application.vala"
		greeter_settings_portal_register_object (_tmp0_, connection, "/org/freedesktop/portal/desktop", &_inner_error0_);
#line 53 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "Application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 52 "../src/Application.vala"
		e = _inner_error0_;
#line 52 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 55 "../src/Application.vala"
		_tmp1_ = e;
#line 55 "../src/Application.vala"
		_tmp2_ = _tmp1_->message;
#line 55 "../src/Application.vala"
		g_critical ("Application.vala:55: Unable to register the object: %s", _tmp2_);
#line 52 "../src/Application.vala"
		_g_error_free0 (e);
#line 280 "Application.c"
	}
	__finally0:
#line 52 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 52 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 52 "../src/Application.vala"
		return;
#line 291 "Application.c"
	}
}

static void
___lambda4__gbus_acquired_callback (GDBusConnection* connection,
                                    const gchar* name,
                                    gpointer self)
{
#line 47 "../src/Application.vala"
	__lambda4_ ((GreeterApplication*) self, connection, name);
#line 302 "Application.c"
}

static void
__lambda6_ (GreeterApplication* self)
{
#line 58 "../src/Application.vala"
	g_debug ("Application.vala:58: org.freedesktop.portal.Desktop acquired");
#line 310 "Application.c"
}

static void
___lambda6__gbus_name_acquired_callback (GDBusConnection* connection,
                                         const gchar* name,
                                         gpointer self)
{
#line 47 "../src/Application.vala"
	__lambda6_ ((GreeterApplication*) self);
#line 320 "Application.c"
}

static void
__lambda7_ (GreeterApplication* self)
{
#line 59 "../src/Application.vala"
	g_debug ("Application.vala:59: org.freedesktop.portal.Desktop lost");
#line 328 "Application.c"
}

static void
___lambda7__gbus_name_lost_callback (GDBusConnection* connection,
                                     const gchar* name,
                                     gpointer self)
{
#line 47 "../src/Application.vala"
	__lambda7_ ((GreeterApplication*) self);
#line 338 "Application.c"
}

static void
__lambda8_ (Block1Data* _data1_)
{
	GreeterApplication* self;
	gint _tmp0_;
	gint _tmp1_;
#line 67 "../src/Application.vala"
	self = _data1_->self;
#line 68 "../src/Application.vala"
	_tmp0_ = greeter_settings_portal_get_prefers_color_scheme (_data1_->settings_portal);
#line 68 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 68 "../src/Application.vala"
	g_object_set (_data1_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp1_ == 1, NULL);
#line 355 "Application.c"
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 67 "../src/Application.vala"
	__lambda8_ (self);
#line 365 "Application.c"
}

static GVariant*
_variant_new1 (const gchar* value)
{
#line 91 "../src/Application.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 373 "Application.c"
}

static void
__lambda9_ (Block1Data* _data1_,
            LightDMSession* session)
{
	GreeterApplication* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
#line 93 "../src/Application.vala"
	self = _data1_->self;
#line 93 "../src/Application.vala"
	g_return_if_fail (session != NULL);
#line 94 "../src/Application.vala"
	_tmp0_ = lightdm_session_get_name (session);
#line 94 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 94 "../src/Application.vala"
	_tmp2_ = lightdm_session_get_key (session);
#line 94 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 94 "../src/Application.vala"
	_tmp4_ = g_variant_new_string (_tmp3_);
#line 94 "../src/Application.vala"
	g_variant_ref_sink (_tmp4_);
#line 94 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 94 "../src/Application.vala"
	g_variant_dict_insert_value (_data1_->vardict, _tmp1_, _tmp5_);
#line 94 "../src/Application.vala"
	_g_variant_unref0 (_tmp5_);
#line 409 "Application.c"
}

static void
___lambda9__gfunc (gconstpointer data,
                   gpointer self)
{
#line 93 "../src/Application.vala"
	__lambda9_ (self, (LightDMSession*) data);
#line 418 "Application.c"
}

static void
__lambda10_ (Block1Data* _data1_,
             GVariant* param)
{
	GreeterApplication* self;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_;
#line 98 "../src/Application.vala"
	self = _data1_->self;
#line 99 "../src/Application.vala"
	_tmp0_ = g_action_get_state ((GAction*) _data1_->select_session_action);
#line 99 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/Application.vala"
	_tmp2_ = !g_variant_equal (_tmp1_, param);
#line 99 "../src/Application.vala"
	_g_variant_unref0 (_tmp1_);
#line 99 "../src/Application.vala"
	if (_tmp2_) {
#line 100 "../src/Application.vala"
		g_simple_action_set_state (_data1_->select_session_action, param);
#line 443 "Application.c"
	}
}

static void
___lambda10__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 98 "../src/Application.vala"
	__lambda10_ (self, parameter);
#line 454 "Application.c"
}

static void
greeter_application_real_startup (GApplication* base)
{
	GreeterApplication * self;
	Block1Data* _data1_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GdkScreen* _tmp1_;
	GtkSettings* _tmp2_;
	GreeterSettingsPortal* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GSettings* settings = NULL;
	GSettings* _tmp6_;
	LightDMGreeter* _tmp7_;
	GList* sessions = NULL;
	GList* _tmp11_;
	gchar* selected_session = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean _tmp15_;
	const GVariantType* _tmp31_;
	const gchar* _tmp32_;
	GVariant* _tmp33_;
	GSimpleAction* _tmp34_;
	GSimpleAction* _tmp35_;
	GVariantDict* _tmp36_;
	GList* _tmp37_;
	GVariant* _tmp38_;
	GVariant* _tmp39_;
	GError* _inner_error0_ = NULL;
#line 39 "../src/Application.vala"
	self = (GreeterApplication*) base;
#line 39 "../src/Application.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 39 "../src/Application.vala"
	_data1_->_ref_count_ = 1;
#line 39 "../src/Application.vala"
	_data1_->self = g_object_ref (self);
#line 40 "../src/Application.vala"
	G_APPLICATION_CLASS (greeter_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 42 "../src/Application.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 42 "../src/Application.vala"
	css_provider = _tmp0_;
#line 43 "../src/Application.vala"
	gtk_css_provider_load_from_resource (css_provider, "/io/elementary/greeter/Application.css");
#line 45 "../src/Application.vala"
	_tmp1_ = gdk_screen_get_default ();
#line 45 "../src/Application.vala"
	gtk_style_context_add_provider_for_screen (_tmp1_, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 47 "../src/Application.vala"
	g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.freedesktop.portal.Desktop", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((___lambda4__gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda4__gbus_acquired_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((___lambda6__gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda6__gbus_name_acquired_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((___lambda7__gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda7__gbus_name_lost_callback, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 62 "../src/Application.vala"
	_tmp2_ = gtk_settings_get_default ();
#line 62 "../src/Application.vala"
	_data1_->gtk_settings = _tmp2_;
#line 63 "../src/Application.vala"
	_tmp3_ = greeter_settings_portal_get_default ();
#line 63 "../src/Application.vala"
	_data1_->settings_portal = _tmp3_;
#line 65 "../src/Application.vala"
	_tmp4_ = greeter_settings_portal_get_prefers_color_scheme (_data1_->settings_portal);
#line 65 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 65 "../src/Application.vala"
	g_object_set (_data1_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp5_ == 1, NULL);
#line 67 "../src/Application.vala"
	g_signal_connect_data ((GObject*) _data1_->settings_portal, "notify::prefers-color-scheme", (GCallback) ___lambda8__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 71 "../src/Application.vala"
	_tmp6_ = g_settings_new ("io.elementary.greeter");
#line 71 "../src/Application.vala"
	settings = _tmp6_;
#line 73 "../src/Application.vala"
	_tmp7_ = lightdm_greeter_new ();
#line 73 "../src/Application.vala"
	_g_object_unref0 (self->priv->lightdm_greeter);
#line 73 "../src/Application.vala"
	self->priv->lightdm_greeter = _tmp7_;
#line 537 "Application.c"
	{
		LightDMGreeter* _tmp8_;
#line 75 "../src/Application.vala"
		_tmp8_ = self->priv->lightdm_greeter;
#line 75 "../src/Application.vala"
		lightdm_greeter_connect_to_daemon_sync (_tmp8_, &_inner_error0_);
#line 75 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 546 "Application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 74 "../src/Application.vala"
		e = _inner_error0_;
#line 74 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 77 "../src/Application.vala"
		_tmp9_ = e;
#line 77 "../src/Application.vala"
		_tmp10_ = _tmp9_->message;
#line 77 "../src/Application.vala"
		g_critical ("Application.vala:77: LightDM couldn't connect to daemon: %s", _tmp10_);
#line 74 "../src/Application.vala"
		_g_error_free0 (e);
#line 568 "Application.c"
	}
	__finally0:
#line 74 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/Application.vala"
		_g_object_unref0 (settings);
#line 74 "../src/Application.vala"
		_g_object_unref0 (css_provider);
#line 74 "../src/Application.vala"
		block1_data_unref (_data1_);
#line 74 "../src/Application.vala"
		_data1_ = NULL;
#line 74 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 74 "../src/Application.vala"
		return;
#line 587 "Application.c"
	}
#line 80 "../src/Application.vala"
	_tmp11_ = lightdm_get_sessions ();
#line 80 "../src/Application.vala"
	sessions = _tmp11_;
#line 82 "../src/Application.vala"
	_tmp12_ = g_strdup ("");
#line 82 "../src/Application.vala"
	selected_session = _tmp12_;
#line 83 "../src/Application.vala"
	_tmp13_ = g_settings_get_string (settings, "last-session-type");
#line 83 "../src/Application.vala"
	_tmp14_ = _tmp13_;
#line 83 "../src/Application.vala"
	_tmp15_ = g_strcmp0 (_tmp14_, "") != 0;
#line 83 "../src/Application.vala"
	_g_free0 (_tmp14_);
#line 83 "../src/Application.vala"
	if (_tmp15_) {
#line 607 "Application.c"
		gchar* _tmp16_;
#line 84 "../src/Application.vala"
		_tmp16_ = g_settings_get_string (settings, "last-session-type");
#line 84 "../src/Application.vala"
		_g_free0 (selected_session);
#line 84 "../src/Application.vala"
		selected_session = _tmp16_;
#line 615 "Application.c"
	} else {
		LightDMGreeter* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
#line 85 "../src/Application.vala"
		_tmp17_ = self->priv->lightdm_greeter;
#line 85 "../src/Application.vala"
		_tmp18_ = lightdm_greeter_get_default_session_hint (_tmp17_);
#line 85 "../src/Application.vala"
		_tmp19_ = _tmp18_;
#line 85 "../src/Application.vala"
		if (_tmp19_ != NULL) {
#line 628 "Application.c"
			LightDMGreeter* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
#line 86 "../src/Application.vala"
			_tmp20_ = self->priv->lightdm_greeter;
#line 86 "../src/Application.vala"
			_tmp21_ = lightdm_greeter_get_default_session_hint (_tmp20_);
#line 86 "../src/Application.vala"
			_tmp22_ = _tmp21_;
#line 86 "../src/Application.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 86 "../src/Application.vala"
			_g_free0 (selected_session);
#line 86 "../src/Application.vala"
			selected_session = _tmp23_;
#line 645 "Application.c"
		} else {
			GList* _tmp24_;
#line 87 "../src/Application.vala"
			_tmp24_ = sessions;
#line 87 "../src/Application.vala"
			if (g_list_length (_tmp24_) > ((guint) 0)) {
#line 652 "Application.c"
				GList* _tmp25_;
				GList* _tmp26_;
				gconstpointer _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				gchar* _tmp30_;
#line 88 "../src/Application.vala"
				_tmp25_ = sessions;
#line 88 "../src/Application.vala"
				_tmp26_ = g_list_first (_tmp25_);
#line 88 "../src/Application.vala"
				_tmp27_ = _tmp26_->data;
#line 88 "../src/Application.vala"
				_tmp28_ = lightdm_session_get_key ((LightDMSession*) _tmp27_);
#line 88 "../src/Application.vala"
				_tmp29_ = _tmp28_;
#line 88 "../src/Application.vala"
				_tmp30_ = g_strdup (_tmp29_);
#line 88 "../src/Application.vala"
				_g_free0 (selected_session);
#line 88 "../src/Application.vala"
				selected_session = _tmp30_;
#line 675 "Application.c"
			}
		}
	}
#line 91 "../src/Application.vala"
	_tmp31_ = G_VARIANT_TYPE_STRING;
#line 91 "../src/Application.vala"
	_tmp32_ = selected_session;
#line 91 "../src/Application.vala"
	_tmp33_ = _variant_new1 (_tmp32_);
#line 91 "../src/Application.vala"
	_tmp34_ = g_simple_action_new_stateful ("select-session", _tmp31_, _tmp33_);
#line 91 "../src/Application.vala"
	_tmp35_ = _tmp34_;
#line 91 "../src/Application.vala"
	_g_variant_unref0 (_tmp33_);
#line 91 "../src/Application.vala"
	_data1_->select_session_action = _tmp35_;
#line 92 "../src/Application.vala"
	_tmp36_ = g_variant_dict_new (NULL);
#line 92 "../src/Application.vala"
	_data1_->vardict = _tmp36_;
#line 93 "../src/Application.vala"
	_tmp37_ = sessions;
#line 93 "../src/Application.vala"
	g_list_foreach (_tmp37_, ___lambda9__gfunc, _data1_);
#line 96 "../src/Application.vala"
	_tmp38_ = g_variant_dict_end (_data1_->vardict);
#line 96 "../src/Application.vala"
	g_variant_ref_sink (_tmp38_);
#line 96 "../src/Application.vala"
	_tmp39_ = _tmp38_;
#line 96 "../src/Application.vala"
	g_simple_action_set_state_hint (_data1_->select_session_action, _tmp39_);
#line 96 "../src/Application.vala"
	_g_variant_unref0 (_tmp39_);
#line 98 "../src/Application.vala"
	g_signal_connect_data (_data1_->select_session_action, "activate", (GCallback) ___lambda10__g_simple_action_activate, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 104 "../src/Application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _data1_->select_session_action);
#line 39 "../src/Application.vala"
	_g_free0 (selected_session);
#line 39 "../src/Application.vala"
	_g_object_unref0 (settings);
#line 39 "../src/Application.vala"
	_g_object_unref0 (css_provider);
#line 39 "../src/Application.vala"
	block1_data_unref (_data1_);
#line 39 "../src/Application.vala"
	_data1_ = NULL;
#line 725 "Application.c"
}

static void
greeter_application_real_activate (GApplication* base)
{
	GreeterApplication * self;
	LightDMGreeter* _tmp0_;
	GreeterMainWindow* _tmp1_;
	GreeterMainWindow* _tmp2_;
	GtkWindow* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
	GtkWindow* _tmp6_;
#line 107 "../src/Application.vala"
	self = (GreeterApplication*) base;
#line 108 "../src/Application.vala"
	_tmp0_ = self->priv->lightdm_greeter;
#line 108 "../src/Application.vala"
	_tmp1_ = greeter_main_window_new (_tmp0_);
#line 108 "../src/Application.vala"
	g_object_ref_sink (_tmp1_);
#line 108 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 108 "../src/Application.vala"
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp2_);
#line 108 "../src/Application.vala"
	_g_object_unref0 (_tmp2_);
#line 109 "../src/Application.vala"
	_tmp3_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 109 "../src/Application.vala"
	_tmp4_ = _tmp3_;
#line 109 "../src/Application.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp4_);
#line 110 "../src/Application.vala"
	_tmp5_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 110 "../src/Application.vala"
	_tmp6_ = _tmp5_;
#line 110 "../src/Application.vala"
	gtk_window_present (_tmp6_);
#line 765 "Application.c"
}

static gint
greeter_application_main (gchar** args,
                          gint args_length1)
{
	GreeterApplication* _tmp0_;
	GreeterApplication* _tmp1_;
	gint _tmp2_;
	gint result;
#line 114 "../src/Application.vala"
	_tmp0_ = greeter_application_new ();
#line 114 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/Application.vala"
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
#line 114 "../src/Application.vala"
	_g_object_unref0 (_tmp1_);
#line 114 "../src/Application.vala"
	result = _tmp2_;
#line 114 "../src/Application.vala"
	return result;
#line 788 "Application.c"
}

int
main (int argc,
      char ** argv)
{
#line 113 "../src/Application.vala"
	return greeter_application_main (argv, argc);
#line 797 "Application.c"
}

static GObject *
greeter_application_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GreeterApplication * self;
#line 32 "../src/Application.vala"
	parent_class = G_OBJECT_CLASS (greeter_application_parent_class);
#line 32 "../src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_APPLICATION, GreeterApplication);
#line 33 "../src/Application.vala"
	setlocale (LC_ALL, "");
#line 34 "../src/Application.vala"
	bind_textdomain_codeset (CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
#line 35 "../src/Application.vala"
	textdomain (CONSTANTS_GETTEXT_PACKAGE);
#line 36 "../src/Application.vala"
	bindtextdomain (CONSTANTS_GETTEXT_PACKAGE, CONSTANTS_LOCALE_DIR);
#line 32 "../src/Application.vala"
	return obj;
#line 824 "Application.c"
}

static void
greeter_application_class_init (GreeterApplicationClass * klass,
                                gpointer klass_data)
{
#line 22 "../src/Application.vala"
	greeter_application_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &GreeterApplication_private_offset);
#line 22 "../src/Application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) greeter_application_real_startup;
#line 22 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) greeter_application_real_activate;
#line 22 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = greeter_application_constructor;
#line 22 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = greeter_application_finalize;
#line 843 "Application.c"
}

static void
greeter_application_instance_init (GreeterApplication * self,
                                   gpointer klass)
{
#line 22 "../src/Application.vala"
	self->priv = greeter_application_get_instance_private (self);
#line 852 "Application.c"
}

static void
greeter_application_finalize (GObject * obj)
{
	GreeterApplication * self;
#line 22 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_APPLICATION, GreeterApplication);
#line 23 "../src/Application.vala"
	_g_object_unref0 (self->priv->lightdm_greeter);
#line 22 "../src/Application.vala"
	G_OBJECT_CLASS (greeter_application_parent_class)->finalize (obj);
#line 865 "Application.c"
}

static GType
greeter_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GreeterApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterApplication), 0, (GInstanceInitFunc) greeter_application_instance_init, NULL };
	GType greeter_application_type_id;
	greeter_application_type_id = g_type_register_static (gtk_application_get_type (), "GreeterApplication", &g_define_type_info, 0);
	GreeterApplication_private_offset = g_type_add_instance_private (greeter_application_type_id, sizeof (GreeterApplicationPrivate));
	return greeter_application_type_id;
}

GType
greeter_application_get_type (void)
{
	static volatile gsize greeter_application_type_id__once = 0;
	if (g_once_init_enter (&greeter_application_type_id__once)) {
		GType greeter_application_type_id;
		greeter_application_type_id = greeter_application_get_type_once ();
		g_once_init_leave (&greeter_application_type_id__once, greeter_application_type_id);
	}
	return greeter_application_type_id__once;
}

